#include <sys/types.h>

#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

#include <X11/X.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Xutil.h>
#include <X11/MwmUtil.h>
#include <X11/Xlib.h>
#include <X11/Shell.h>

#include <Xm/Xm.h>
#include <Xm/CascadeB.h>
#include <Xm/CascadeBG.h>
#include <Xm/ArrowB.h>
#include <Xm/ArrowBG.h>
#include <Xm/PushB.h>
#include <Xm/PushBG.h>
#include <Xm/ToggleB.h>
#include <Xm/ToggleBG.h>
#include <Xm/Label.h>
#include <Xm/Text.h>
#include <Xm/TextF.h>

void
cx_set_str(Widget w, char *new_string)

{ static char   kws[] = "@(#)cx_set_str.c	1.1 ARGOS 94/02/25 11:05:58";

  int       nn = 0;
  Arg       args[10];
  XmString    tcs;
  char       *current;
  int       ip;

/* c y a */

  if (!w)
    return;

  if (!new_string)
    return;

/* Labels and Buttons */

  if (XtIsSubclass(w, xmLabelWidgetClass)
    || XtIsSubclass(w, xmLabelGadgetClass)) {
    tcs = XmStringLtoRCreate(new_string, XmSTRING_DEFAULT_CHARSET);
    XtSetArg(args[nn], XmNlabelString, tcs);
    nn++;
    XtSetValues(w, args, nn);
    XmStringFree(tcs);
  }

/* Replace only if differs to avoid blinking of same value. */

  else if (XtClass(w) == xmTextFieldWidgetClass) {
    current = XmTextFieldGetString(w);
    if (strcmp(current, new_string)) {
      ip = XmTextFieldGetInsertionPosition(w);
      XmTextFieldSetString(w, new_string);
      XmTextFieldSetInsertionPosition(w, ip);
    }
    XtFree(current);
  }

  else if (XtClass(w) == xmTextWidgetClass) {
    current = XmTextGetString(w);
    if (strcmp(current, new_string)) {
      ip = XmTextGetInsertionPosition(w);
      XmTextSetString(w, new_string);
      XmTextSetInsertionPosition(w, ip);
    }
    XtFree(current);
  }
}
