/* cycle_l.c
   called as a decoder
   cycle string to long */

#include <string.h>

static char * awordx(int wx, char *words)

/* Count wx words into list and return that word. */

{ static char aword[100];

    int             count = 0;
    int             length;

  aword[0] = '\0';

/* Return empty string if given null or empty string. */

    while (words && *words && (count <= wx)) {

/* Skip leading blank spaces or tabs. */

	while (*words == ' ' || *words == '\t')
	    words++;

/* Scan length of a word.
   Copy it only if the one we want. */

	length = 0;
	while ((*words) && (*words != ' ') && (*words != '\t')) {
	    if (wx == count)
		aword[length] = *words;
	    words++;
	    length++;
	}
	aword[length] = '\0';

/* Count the word. */

	if (length)
	    count++;
    }
    return aword;
}

long cycle_l(char *buff, char *nameset, int ud, long *val)

{ static char     kws[] = "@(#)cycle_l.c	1.1 ARGOS 93/12/13 17:37:02";

    long            ii;
    char           *chtemp;

    int             lbuff = strlen(buff);

/* note the minus one! */

    int             lset = wordcount(nameset) -1;

/* attempt to match any cycle line to the current buffer */

    for (ii = 0;
	 ((chtemp = awordx(ii, nameset))
	  && chtemp[0]);
	 ii++) {
	if (strncasecmp(buff, chtemp, lbuff) == 0) {

/* matched the buffer-so-far but need more to complete */

	    if (strlen(chtemp) > lbuff)
		return 0;

/* buffer exactly matches a cycle name giving an index,
   shift to next or prev index per click up down if any,
   otherwise index as name was found.
   must correct for wrap-around. */

	    if (ud > 0) {
		ii++;
                if (ii > lset)
                    ii = 0;
            }

	    else if (ud < 0) {
		ii--;
                if (ii < 0)
                    ii = lset;
            }

	    *val = ii;

	    return 1;
	}
    }

/* can not match any name,
   something bad typed in */

    return -1;
}
