/* hhmmss_d.c
   hhmmss to double total seconds */

#include <stdio.h>
#include <string.h>

long hhmmss_d(char *buff, int col, int ud, double *value)

{ static char     kws[] = "@(#)hhmmss_d.c	1.1 ARGOS 93/12/13 17:37:08";

    int             hrs, mins, secs;

    int             delta;
    double          valtemp;

/* attempt to decode the current buffer */

    switch (sscanf(buff, "%d %d %d", &hrs, &mins, &secs)) {

/* correctly accepted all of the buffer but need more */

    case EOF:
	return 0;

/* accepted enough (but could have junk at end) */

    case 3:

/* up or down by ones and tens of h m s.
   carry ones to tens but no carry between h m s.
   other styles are possible. */

	if (ud > 0) {
	    switch (col) {
	    case 0:
		secs += 1;
		break;
	    case 1:
		secs += 10;
		break;

	    case 3:
		mins += 1;
		break;
	    case 4:
		mins += 10;
		break;

	    case 6:
		hrs += 1;
		break;
	    case 7:
		hrs += 10;
		break;
	    }
	}

	else if (ud < 0) {
	    switch (col) {
	    case 0:
		secs -= 1;
		break;
	    case 1:
		secs -= 10;
		break;

	    case 3:
		mins -= 1;
		break;
	    case 4:
		mins -= 10;
		break;

	    case 6:
		hrs -= 1;
		break;
	    case 7:
		hrs -= 10;
		break;
	    }
	}

        while (secs > 59)
            secs -= 60;

        while (secs < 0)
            secs += 60;

        while (mins > 59)
            mins -= 60;

        while (mins < 0)
            mins += 60;

        if (hrs < 0)
            hrs = 0;

	valtemp = (double) ((hrs * 3600) + (mins * 60) + secs);

	*value = valtemp;
	return 1;

/* something bad in buffer */

    default:
	return -1;
    }
}
