#include "gui_comm.h"

void uidiscard(void)

/* Discard the current top dictionary.
   Parent then becomes top valid dictionary.
   (The node AND dictionary active level is popped.) */

{ static char   vers[] = "@(#)uidiscard.c	1.1 ARGOS 93/12/13 17:37:13";

    UIDATA     *top;
    UIDATA     *next;

#ifdef DEBUG
    if (DEBUG)
        fprintf(DEBUG,
            "uidiscard: %s %d\n", Node_Name(UITOP), UITOP);
#endif

    if (!Actives)
        return;

/* Loop on all contents of the top dictionary.
   Notice we decremented active level at start of the loop! */

    for (top = Data[Actives], Data[Actives--] = 0;
         top;
         top = next) {

/* Save this link before we may lose it. */

        next = Data_Sibling(top);

        switch (Data_Kind(top)) {
        case LONGVAL:
        case FLOATVAL:
        case DOUBLEVAL:
            break;

/* STRINGVAL and any structure types use allocated memory. */

        default:
            free(Data_SValue(top));
            break;
        }
        free(Data_Name(top));
        free(top);
    }
}
