#include <stdio.h>
#include <string.h>

#include "uitoc_comm.h"

#define UITOP Active_Nodes[Actives]
#define UIPARENT Active_Nodes[Actives-1]
#define ROOTNODE 1

int uisubtree(char *pathname)

/* Validate name as an existing subtree,
   but not a direct ancestor or a sibling in the current top.
   Return node number else null. */

{ static char     kws[] = "@(#)uisubtree.c	1.1 ARGOS 93/12/13 17:37:18";

    int             node = ROOTNODE;
    int             tokptr = 0;
    int             starting = 1;

#define MAXPATHCH 100
    char            full_name[MAXPATHCH];
    char           *this_name;

/* Separate the path name.
   Work with a copy because it will be trashed by separation.
   Start beyond the leading slash for root name. */

    strncpy(full_name, pathname+1, MAXPATHCH);

/* First part must match root name */

    this_name = mystrtok(full_name, &tokptr);
    if (strcasecmp(this_name, Node_Name(node)))
	return 0;

/* Later parts must match some child of last match */

    for (this_name = mystrtok(full_name, &tokptr);
	 this_name && node;
	 this_name = mystrtok(full_name, &tokptr)) {

	for (node = Node_Child(node);
	     node;
	     node = Node_Sibling(node)) {
	    if (!strcasecmp(this_name, Node_Name(node))) {
	        break;
	    }
        }
    }

/* Too much name */

    if (this_name)
	node = 0;

/* NOT YET TESTING THESE!
   should not be a direct ancestor of the current top,
   or a sibling in the current top. */

    return node;
}
